import { Context, IDeleteOperationParams, IInsertOperationParams, IModifyOperationParams } from "./types";
import { IExecuteWithRetryParams } from "./executeWithRetry";
import { ITimer } from "@webiny/handler-aws";
export type ISynchronizationBuilderExecuteWithRetryParams = Omit<IExecuteWithRetryParams, "context" | "timer" | "maxRunningTime" | "operations">;
export interface ISynchronizationBuilder {
    insert(params: IInsertOperationParams): void;
    delete(params: IDeleteOperationParams): void;
    build: () => (params?: ISynchronizationBuilderExecuteWithRetryParams) => Promise<void>;
}
export interface ISynchronizationBuilderParams {
    timer: ITimer;
    context: Pick<Context, "elasticsearch">;
}
export declare class SynchronizationBuilder implements ISynchronizationBuilder {
    private readonly timer;
    private readonly context;
    private readonly operations;
    constructor(params: ISynchronizationBuilderParams);
    insert(params: IInsertOperationParams): void;
    modify(params: IModifyOperationParams): void;
    delete(params: IDeleteOperationParams): void;
    build(): (params?: ISynchronizationBuilderExecuteWithRetryParams) => Promise<void>;
}
export declare const createSynchronizationBuilder: (params: ISynchronizationBuilderParams) => ISynchronizationBuilder;
